/**
 * @(#)Algorithms.java  6 November 2006
 *
 * @author Viera K. Proulx
 */

import edu.neu.ccs.*;
import edu.neu.ccs.util.*;
import edu.neu.ccs.console.*;

import java.awt.*;
import java.math.*;
import java.util.*;
/**
 * Class that implements generic traversal-based algorithms
 */
public class Algorithms<T> implements ConsoleAware{
  
  /**
   * Recursively implemented orMap
   * 
   * @param tr the source of the data
   * @param predicate the predicate that provides the select method
   * @return true if there is an item that satisfies the given predicate
   */
  public boolean orMap(Traversal<T> tr, ISelect<T> predicate){
    if (!tr.isEmpty())
      return (predicate.select(tr.getFirst())) ||
      orMap(tr.getRest(), predicate);
    else
      return false;
  }
  
  // header for the map method:
  // public <S>  AList<S> map(Traversal<T> tr, IObj2Obj<T, S> transform){
  
}

