/**
 * @(#)CopyTests.java  1.0  6 November 2006
 *
 * @author Viera K. Proulx
 */
/**
 * Class that implements three ways to copy a list of cities.
 * 
 */class CopyTests {
  City nyc = new City();
  City boston1 = new City(02115, "Boston", "MA", 78.123345, 40.987654);
  City bos = new City(this.boston1);
  
  City plymouth = new City(48170,    "Plymouth",  "MI", 83.479946, 42.36882);
  City tuscon   = new City(85745,    "Tucson",    "AZ", 111.017907, 32.243359);
  City madriver = new City(95552,    "Mad River", "CA", 123.413994, 40.352352);
  City atlanta1 = new City(30319,    "Atlanta",   "GA", 84.335091, 33.868728);
  City atlanta2 = new City(30324,    "Atlanta",   "GA", 84.354867, 33.820609);
  City lexingtonGA = new City(30648, "Lexington", "GA", 83.085809, 33.879913);
  City lexingtonMA = new City(02173, "Lexington", "MA", 71.225916, 42.445384);
  City vail        = new City(81657, "Vail",      "CO", 106.463454, 39.623793);
  City boston2  = new City(02115,    "Boston",    "MA", 71.092215, 42.342706);     
  
  /** A sample list of cities. */
  AList<City> list1 = 
    new ConsList<City>(plymouth,
        new ConsList<City>(tuscon,
            new ConsList<City>(madriver,
                new ConsList<City>(atlanta1,
                    new MTList<City>()))));
  
  /**
   * Produce a new 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>
   * that is a reference to the given 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>.
   */
  AList<City> copyAssign(AList<City> source){
    AList<City> target = source;
    return target;
  }
  
  /**
   * Produce a new 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>
   * that contains the same objects as the given 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>.
   */
  AList<City> copyShallow(AList<City> source){
    if (source instanceof MTList)
      return source;
    else {
      AList<City> target = 
        new ConsList<City>(
            ((ConsList<City>)source).first, 
            copyShallow(((ConsList<City>)source).rest));
      return target;
    }
  }
  
  /**
   * Produce a deep copy of the 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>
   * from the values of the given 
   * <CODE>{@link AListOfCities AListOfCities}</CODE>.
   */
  AList<City> copyDeep(AList<City> source){
    if (source instanceof MTList)
      return source;
    else {
      AList<City> target = 
        new ConsList<City>(
            copyCity(((ConsList<City>)source).first), 
            copyDeep(((ConsList<City>)source).rest));
      return target;
    }
  }
  
  /**
   * Produce a new instance of the <CODE>{@link City City}</CODE>
   * from the values of the given <CODE>{@link City City}</CODE>.
   */
  City copyCity(City source){
    return new City(source.zip, source.name, source.state, 
        source.latitude, source.longitude);
  }
  
  
}