import java.util.*;

public class Examples extends TraversalTestHarness{
  
  Algorithms<City> a = new Algorithms<City>();
  
  City nyc = new City();
  City boston = new City(02115, "Boston", "MA", 78.123345, 40.987654);
  City bos = new City(this.boston);
  
  City plymouth = new City(48170, "Plymouth",  "MI", 83.479946, 42.36882);
  City lexingtonGA = new City(30648, "Lexington", "GA", 83.085809, 33.879913);
  City lexingtonMA = new City(02173, "Lexington", "MA", 71.225916, 42.445384);
  City vail = new City(81657, "Vail", "CO", 106.463454, 39.623793);
  City bostonMA = new City(02115, "Boston", "MA", 71.092215, 42.342706);
  
  AList<City> mtlist = new MTList<City>();
  AList<City> mylist = 
    new ConsList<City>(plymouth,
        new ConsList<City>(lexingtonGA,
            new ConsList<City>(lexingtonMA,
                new ConsList<City>(lexingtonGA,
                    new ConsList<City>(vail,
                        new ConsList<City>(bostonMA, mtlist))))));
  
  AList<City> mylistByNameState = 
    new ConsList<City>(bostonMA,
        new ConsList<City>(lexingtonGA,
            new ConsList<City>(lexingtonGA,
                new ConsList<City>(lexingtonMA,
                    new ConsList<City>(plymouth,
                        new ConsList<City>(vail, mtlist))))));

  AList<City> mylistByStateName = 
    new ConsList<City>(vail,
        new ConsList<City>(lexingtonGA,
            new ConsList<City>(lexingtonGA,
                new ConsList<City>(bostonMA,
                    new ConsList<City>(lexingtonMA,
                        new ConsList<City>(plymouth, mtlist))))));

  AList<City> mylistByLatitude = 
    new ConsList<City>(lexingtonGA,
        new ConsList<City>(lexingtonGA,
            new ConsList<City>(vail,
                new ConsList<City>(bostonMA,
                    new ConsList<City>(plymouth,
                        new ConsList<City>(lexingtonMA, mtlist))))));
  
   AList<City> allMA = 
    new ConsList<City>(lexingtonMA,
        new ConsList<City>(bostonMA, mtlist));
  
  AList<City> noMA = 
    new ConsList<City>(plymouth,
        new ConsList<City>(lexingtonGA,
            new ConsList<City>(lexingtonGA,
                new ConsList<City>(vail, mtlist))));
  
  AList<City> single = 
    new ConsList<City>(lexingtonMA, mtlist);
 
  public void runTests(){
    
    /* test the Traversal methods in the AList<City> classes */
    test("traversal - empty", mtlist.isEmpty(), true);
    test("traversal - more", noMA.isEmpty(), false);
    test("traversal - current", plymouth.same(noMA.getFirst()), true);
    test("traversal - current", lexingtonMA.same(single.getFirst()), true);
    test("traversal - advance", single.getRest().isEmpty(), true);
    
    /* test the method orMap in the Algorithms class
     * does a list of cities has a city in a given state */
    test("cities in a given state? - empty",
        a.orMap(mtlist, new GivenState("MA")), false);
    test("cities in a given state? - mylist, MA",
        a.orMap(mylist, new GivenState("MA")), true);
    test("cities in a given state? - noMA, MA",
        a.orMap(noMA, new GivenState("MA")), false);
    
    test("Zip code converter", 12345, this.boston.decimal("12345"));
    test("Zip code converter", 2145, this.boston.decimal("02145"));
    
    test("Same City", false, this.nyc.same(this.boston));
    
    testReport();
    fullTestReport();
  }
 
}