/**
 * @(#)IObj2Obj.java  6 November 2006
 *
 * @author Viera K. Proulx
 */
/** 
 * Interface for a method that produces a new object from 
 * the given object.
 */
public interface IObj2Obj<T, S>{
  /**
   * Produce from the given object another one.
   * 
   * @param obj the source object.
   * @return the target object.
   */
  public S apply(T obj);
}