/**
 * @(#)MTList.java  6 November 2006
 *
 * @author Viera K. Proulx
 */
import java.util.*;
/**
 * A class to represent an empty list of cities.
 */
public class MTList<T> extends AList<T>{

  /*---------------------------------------------------------------
  Implementing Traversal
  --------------------------------------------------------------*/
  /* produce a traversal for the rest of this data set */
  public Traversal<T> getRest(){ 
    throw new NoSuchElementException(
        "Cannot advance in an empty list");
  }
  
  /* select the first item in this data set */
  public T getFirst(){ 
    throw new NoSuchElementException(
    "No element available in an empty list");
}
  
  /* test whether there are more items in this data set */
  public boolean isEmpty(){ return true; }
           
 /*---------------------------------------------------------------
  Pretty-printing
  --------------------------------------------------------------*/
  
  /** 
   * Represents this instance as a pretty-printable 
   * <CODE>{@link String String}</CODE>.
   * 
   */
  public String toString(){
        return "***";
    }
    
}
    
